package com.buecoin01.model;


import com.buecoin01.utility.Encryption;

import javax.persistence.*;
import java.time.LocalDateTime;


@Entity
public class Block {

    private String minerID;

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @Column
    private String hash;
    private String previousHash;
    private String data;
    private LocalDateTime timeStamp;
    private int nonce;

    public Block(String previousHash, LocalDateTime time) {
        this.timeStamp = time;
        this.previousHash = previousHash;
    }

    public String getHash() {
        return hash;
    }

    public String getPreviousHash() {
        return previousHash;
    }

    public String getData() {
        return data;
    }

    public LocalDateTime getTimeStamp() {
        return timeStamp;
    }

    public String calculateHash() {
        return Encryption.applySha256(
                  previousHash +
                        timeStamp.toString() +
                        Integer.toString(nonce) +
                        data);
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public void mineBlock(int difficulty) {
        String target = new String(new char[difficulty]).replace('\0', '0'); //Create a string with difficulty * "0"
        while(!hash.substring( 0, difficulty).equals(target)) {
            nonce ++;
            hash = calculateHash();
            System.out.println(hash);
        }
        System.out.println("Block Mined " + hash);
        System.out.println("You have been awarded 1 Zip!");
        Coin coin = new Coin(minerID);
    }
}