package com.buecoin01.model;

import com.buecoin01.model.Block;
import com.buecoin01.utility.Encryption;
import com.google.gson.GsonBuilder;

import java.util.ArrayList;
import java.util.List;

public class Blockchain {
    private static List<Block> blockchain = new ArrayList<>();
    private static int difficulty = 5;

    public String chainToJson() {
        return new GsonBuilder()
                .setPrettyPrinting()
                .create()
                .toJson(blockchain);
    }

    public static List<Block> getBlockchain() {
        return blockchain;
    }

    public static void abbBlockToChain(Block block) {
        blockchain.add(block);
    }

    public static Block getBlockFromChain(int i) {
        return blockchain.get(i);
    }

    public static int getChainSize() {
        return blockchain.size();
    }

    public static boolean isChainValid() {
        Block currentBlock;
        Block previousBlock;
        String hashTarget = Encryption.createTarget(difficulty);
        for (int i = 1; i < blockchain.size()-1; i++) {
            currentBlock = blockchain.get(i);
            previousBlock = blockchain.get(i-1);
            if(!currentBlock.getHash().equals(currentBlock.calculateHash())) {
                System.out.println("Current Hashes aren't equal");
                return false;
            }
            if(!previousBlock.getHash().equals(currentBlock.getPreviousHash())) {
                System.out.println("Previous Hashes aren't equal");
                return false;
            }
            if (!currentBlock.getHash().substring(0, difficulty).equals(hashTarget)) {
                System.out.println("This block hasn't been mined");
                return false;
            }
        }
        return true;
    }
}