package com.buecoin01.model;

import com.buecoin01.utility.Encryption;
import com.buecoin01.utility.TransactionInput;
import com.buecoin01.utility.TransactionOutput;

import java.security.PublicKey;
import java.util.ArrayList;
import java.util.List;

public class Transaction {
    private String transactionId; //hash of the transaction
    private PublicKey sender;
    private PublicKey reciepient;
    private float value;
    private byte[] signature;

    private List<TransactionInput> inputs = new ArrayList<>();
    private List<TransactionOutput> outputs = new ArrayList<>();

    private static int sequence = 0; //how many transactions have been generated

    public Transaction(PublicKey from, PublicKey to, float value, ArrayList<TransactionInput> inputs) {
        this.sender = from;
        this.reciepient = to;
        this.value = value;
        this.inputs = inputs;
    }

    //generating transactionId
    private String calculateHash() {
        sequence++; //increasing tho avoid identical hash codes
        return Encryption.applySha256(
                Encryption.getStringFromKey(sender) +
                       Encryption.getStringFromKey(reciepient) +
                       Float.toString(value) + sequence
                       );
    }
}
