package com.buecoin01.model;

import javax.persistence.*;
import java.security.*;
import java.security.spec.ECGenParameterSpec;

@Entity
public class Wallet {

    private PrivateKey privateKey;
    private PublicKey publicKey;
    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @Column(name = "pubicId")
    private String publicId;
    @Column(name = "amount")
    private long amount;


    public Wallet(String publicId, long amount) {
        this.publicId = publicId;
        this.amount = amount;
    }

    public Wallet() {
        generateKeyPair();
    }
    public long getAmount() {
        return amount;
    }

    public void setAmount(long amount) {
        this.amount = amount;
    }


    public String getPublicId() {

        return publicId;
    }

    public void setPublicId(String publicId) {
        this.publicId = publicId;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public void generateKeyPair() {
        try {
            KeyPairGenerator keyGen = KeyPairGenerator.getInstance("ECDSA","BC");
            SecureRandom random = SecureRandom.getInstance("SHA1PRNG");
            ECGenParameterSpec ecSpec = new ECGenParameterSpec("prime192v1");

            keyGen.initialize(ecSpec, random);
            KeyPair keyPair = keyGen.generateKeyPair();
            privateKey = keyPair.getPrivate();
            publicKey = keyPair.getPublic();
        } catch(Exception e) {
            throw new RuntimeException(e);
        }
    }
}
